var ssOptions = null;

function ssOptionsLoad() 
{
  ssOptions = new ssOptionsManager();
  ssOptions.init();
}

function ssOptionsUnload()
{
  ssOptions.destroy();
  ssOptions = null;
}

function ssOptionsManager()
{
  return this;
}

ssOptionsManager.prototype =
{
  init: function()
  {
    var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
    var branch = preferencesService.getBranch( "extensions.searchstatus." );
    
  	this.barinput = document.getElementById( "barinput" );
  	this.neighborinput = document.getElementById( "neighborinput" );
  	this.aligninput = document.getElementById( "aligninput" );
  	this.privatesitelist = document.getElementById( "privatesitelist" );
  	this.privatemodecheckbox = document.getElementById( "privatemode" ); 
  	this.backgroundopencheckbox = document.getElementById( "backgroundopencheckbox" );
  	this.canonicalbuttoncheckbox = document.getElementById( "canonicalbuttoncheckbox" );
  	this.whoissourceradiogroup = document.getElementById( "whoissourceradiogroup" );
  	
  	this.populateBars();
  	
  	var bar;
  	if( !branch.prefHasUserValue( "searchstatus.bar" ) )
  	{
  		var items = this.barinput.firstChild.childNodes;
  		bar = items[0].getAttribute( "id" );
  		
  		for( var i = 0; i < items.length; i++ )
  		{
  		  if( items[i].getAttribute( "id" ) == "status-bar" )
  		  {
  		    bar = items[i].getAttribute( "id" );
  		  }
  		}
  		
  		branch.setCharPref( "searchstatus.bar", bar );
  	}
  	bar = branch.getCharPref( "searchstatus.bar" );
  	this.barinput.selectedItem = document.getElementById( bar );
  	
  	this.populateNodes();
  	
  	var nextnode;
  	if( !branch.prefHasUserValue( "searchstatus.nextnode" ) )
  	{
  		var items = this.neighborinput.firstChild.childNodes;
  		nextnode = items[0].getAttribute( "id" );
  		
  		for( var i = 0; i < items.length; i++ )
      {
        if( items[i].getAttribute( "id" ) == "statusbar-display" )
        {
          nextnode = items[i].getAttribute( "id" );
        }
      }
  		
  		branch.setCharPref( "searchstatus.nextnode", nextnode );
  	}
  	nextnode = branch.getCharPref( "searchstatus.nextnode" );
  	this.neighborinput.selectedItem = document.getElementById( nextnode );
  	
  	var insertafter;
  	if( !branch.prefHasUserValue( "searchstatus.insertafter" ) )
  	{
  		insertafter = true;
  		branch.setBoolPref( "searchstatus.insertafter", insertafter );
  	}
  	insertafter = branch.getBoolPref( "searchstatus.insertafter" );
  	this.aligninput.selectedItem = document.getElementById( insertafter ? "insertright" : "insertleft" );
  	
  	var privatesitestring;
  	if( !branch.prefHasUserValue( "searchstatus.privatesiteslist" ) )
  	{
  		privatesitestring = "";
  		branch.setCharPref( "searchstatus.privatesiteslist", privatesitestring );
  	}
  	privatesitestring = branch.getCharPref( "searchstatus.privatesiteslist" );
  	var sites = privatesitestring.split( '!' );
  	for( var i = 0; i < sites.length; i++ )
  	{
  		if( sites[i].length > 0 )
  		{
      	this.privatesitelist.appendItem( sites[i] );
     	}
  	}
  	
  	var privatemode = false;
  	this.searchstatusPrivateModeUnset = false;
  	
  	if( branch.prefHasUserValue( "searchstatus.searchstatusprivatemode" ) )
    {
      privatemode = branch.getBoolPref( "searchstatus.searchstatusprivatemode" );
    }
    
    if( !privatemode )
    {
      this.searchstatusPrivateModeUnset = true;
      
      if( !branch.prefHasUserValue( "searchstatus.privatemode" ) )
      {
        privatemode = false;
        branch.setBoolPref( "searchstatus.privatemode", privatemode );
      }
      privatemode = branch.getBoolPref( "searchstatus.privatemode" );
    }
  	this.privatemodecheckbox.setAttribute( "checked", privatemode ? "true" : "false" );
  	
  	var backgroundopen;
  	if( !branch.prefHasUserValue( "searchstatus.backgroundopen" ) )
  	{
  		backgroundopen = false;
  		branch.setBoolPref( "searchstatus.backgroundopen", backgroundopen );
  	}
  	backgroundopen = branch.getBoolPref( "searchstatus.backgroundopen" );
  	this.backgroundopencheckbox.setAttribute( "checked", backgroundopen ? "true" : "false" );
  	
  	var canonicalbutton;
  	if( !branch.prefHasUserValue( "canonicalbutton.state" ) )
  	{
  		canonicalbutton = true;
  		branch.setBoolPref( "canonicalbutton.state", canonicalbutton );
  	}
  	canonicalbutton = branch.getBoolPref( "canonicalbutton.state" );
  	this.canonicalbuttoncheckbox.setAttribute( "checked", canonicalbutton ? "true" : "false" );  	
  	
  	var whoissource;
  	if( !branch.prefHasUserValue( "searchstatus.whoissource" ) )
  	{
  		whoissource = 0;
  		branch.setIntPref( "searchstatus.whoissource", whoissource );
  	}
  	whoissource = branch.getIntPref( "searchstatus.whoissource" );
  	this.whoissourceradiogroup.selectedIndex = whoissource;
  },

  destroy: function()
  {
    
  },
  
  populateBars: function()
  {      
   	// Creates the menuitems for the toolbar selector.
    var topWindow = getTopWindow();
    var toolbars = topWindow.document.getElementsByTagName( "toolbar" );
    var statusbars = topWindow.document.getElementsByTagName( "statusbar" );
    var pnode = document.getElementById( "ssbarpopup" );
    var bar_id, newitem;
          
    toolbars = concat( toolbars, statusbars );
    for( var x = 0; x < toolbars.length; x++ ) 
    {
      bar_id = toolbars[x].getAttribute( "id" );
      //do not include find toolbar
      if( bar_id == "FindToolbar" )
      {
        continue;      	
      }
      
      newitem = document.createElement( "menuitem" );
      newitem.setAttribute( "id", bar_id );
      newitem.setAttribute( "label", bar_id );
      pnode.appendChild( newitem );
    }
  },

  populateNodes: function()
  {
    // Creates the menuitems for the nextnode selector.
    var topWindow = getTopWindow();	      
    var pnode = document.getElementById( "neighborinputpopup" );
    var nodes = pnode.childNodes;
    var bar_id = this.barinput.selectedItem.getAttribute( "id" );
    var node_id, newitem, x;
  
    // Remove all the menuitems currently in the popup.
    while( pnode.firstChild ) 
    {
  		pnode.removeChild( pnode.firstChild );
		}
  
    nodes = topWindow.document.getElementById( bar_id ).childNodes;
    for( x = 0; x < nodes.length; x++ ) 
    {
      node_id = nodes[x].getAttribute( "id" );
  
      // Don't include the searchstatus-bar or generated content in the list.
      if (node_id == "searchstatus-bar" || nodes[x].tagName == "toolbarspacer" || 
        nodes[x].tagName == "toolbarseparator" || nodes[x].tagName == "toolbarspring")
      { 
        continue;
      }
  
      newitem = document.createElement( "menuitem" );
      newitem.setAttribute( "id", node_id );
      newitem.setAttribute( "label", node_id );
      pnode.appendChild( newitem );
    }
  
    // And finally select the first one in the list.
    pnode.parentNode.selectedItem = pnode.firstChild;
  },
  
  addPrivateSite: function()
  {
  	var dlg = window.openDialog('chrome://searchstatus/content/addprivatesite.xul', 'ssaddprivatesite', 'chrome');
  },

  deletePrivateSite: function()
  {
  	var index = this.privatesitelist.selectedIndex;
  	if( index > -1 )
  	{
  		this.privatesitelist.removeItemAt( index );
  	}
  },
  
  updatePrivateSiteButtons: function()
  {
  	var index = this.privatesitelist.selectedIndex;
  	document.getElementById( "deletebutton" ).disabled = ( index == -1 );
  },

  accept: function()
  {
    var preferencesService = Components.classes["@mozilla.org/preferences-service;1"].getService( Components.interfaces.nsIPrefService );
    var branch = preferencesService.getBranch( "extensions.searchstatus." );  	

    try
    {  	
      branch.setCharPref( "searchstatus.bar", this.barinput.selectedItem.getAttribute( "id" ) );
      branch.setCharPref( "searchstatus.nextnode", this.neighborinput.selectedItem.getAttribute( "id" ) );
      branch.setBoolPref( "searchstatus.insertafter", this.aligninput.selectedItem.getAttribute( "id" ) == "insertright" );

    	moveBox( branch );
  	}
  	catch( e )
  	{
  		debugso( e );
  	}
  
  	var itemcount = this.privatesitelist.getRowCount();
  	var privatesitestring = "";
  	for( var i = 0; i < itemcount; i++ )
  	{
  		var item = this.privatesitelist.getItemAtIndex( i );
  		privatesitestring += item.label + "!";
  	}
  	branch.setCharPref( "searchstatus.privatesiteslist", privatesitestring );
  
    var privatemode = ( this.privatemodecheckbox.getAttribute( "checked" ) == "true" );
    if( ( this.searchstatusPrivateModeUnset && privatemode ) || branch.prefHasUserValue( "searchstatus.searchstatusprivatemode" ) )
    {
      branch.setBoolPref( "searchstatus.searchstatusprivatemode", privatemode );
    }
    branch.setBoolPref( "searchstatus.privatemode", privatemode );
  
    var backgroundopen = ( this.backgroundopencheckbox.getAttribute( "checked" ) == "true" );
    branch.setBoolPref( "searchstatus.backgroundopen", backgroundopen );
    
    var canonicalbutton = ( this.canonicalbuttoncheckbox.getAttribute( "checked" ) == "true" );
    branch.setBoolPref( "canonicalbutton.state", canonicalbutton );    
    
    var whoissource = this.whoissourceradiogroup.selectedIndex;
    branch.setIntPref( "searchstatus.whoissource", whoissource );    
  }
};


function moveBox( branch )
{
	var topWindow = getTopWindow();
	
	if( !branch.prefHasUserValue( "searchstatus.bar" ) || !branch.prefHasUserValue( "searchstatus.nextnode" ) || !branch.prefHasUserValue( "searchstatus.insertafter" ) )
	{
		return;
	}
	
  //check if box is in the right location
  var toolbar = topWindow.document.getElementById( branch.getCharPref( "searchstatus.bar" ) );
  var nextnode = topWindow.document.getElementById( branch.getCharPref( "searchstatus.nextnode" ) );
  var insertafter = branch.getBoolPref( "searchstatus.insertafter" );
  var ssbar	= topWindow.document.getElementById( "searchstatus-bar" );
    
  if( toolbar == null || nextnode == null )
  {
  	return;
  } 
    
  // bail if it is in the right place or the prefs are not in sync
  var neighbor = ( (insertafter) ? nextnode.nextSibling : nextnode.previousSibling );
  if( neighbor )
  {
    neighbor = neighbor.getAttribute( "id" );
  }

  if( ( ( neighbor == "searchstatus-bar" ) && ( ssbar.parentNode == toolbar ) ) || ( nextnode.parentNode != toolbar ) ) 
  {
    return;
  }
  
  //remove us from parent
  ssbar.parentNode.removeChild(ssbar);

  //place box
  if( insertafter ) 
  {
    var next_node = nextnode.nextSibling;
    if( next_node )
    {
      toolbar.insertBefore( ssbar, next_node );
    }
    else
    {
      toolbar.appendChild( ssbar );
    }
  }
  else
  {
    toolbar.insertBefore( ssbar, nextnode );
  }
}

function getTopWindow()
{
  var windowManager = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService();
  var windowManagerInterface = windowManager.QueryInterface( Components.interfaces.nsIWindowMediator );
  var topWindow = windowManagerInterface.getMostRecentWindow( "navigator:browser" );
  if( !topWindow )
  {
    topWindow = window.openDialog("chrome://browser/content/browser.xul", "_blank", "chrome,all,dialog=no", "about:blank", null, null);
  }

  return topWindow;
}

function concat( c1, c2 )
{
  // Concats too collections into an array.
  var c3 = new Array( c1.length + c2.length );
  var x,y = 0;

  for( x = 0; x < c1.length; x++ )
  {
    c3[y++] = c1[x];
  }

  for( x = 0; x < c2.length; x++ )
  {
    c3[y++] = c2[x];
  }

  return c3;
}

function debugso( message ) 
{
  //var time = new Date();
  //var time_string = time.getHours() + ":" + time.getMinutes() + ":" + time.getSeconds();
  //dump( "[SearchStatus " + time_string + "]: " + message + "\n" );
  
  var aConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
  aConsoleService.logStringMessage( "SearchStatus: " + message );
}